DPDK patches and discussions
 help / color / mirror / Atom feed
From: Gavin Hu <gavin.hu@arm.com>
To: dev@dpdk.org
Cc: stable@dpdk.org
Subject: [dpdk-dev] [PATCH v6 3/7] devtools: fix the Exec format error
Date: Thu, 14 Jun 2018 17:51:23 +0800	[thread overview]
Message-ID: <20180614095127.16245-4-gavin.hu@arm.com> (raw)
In-Reply-To: <20180614095127.16245-1-gavin.hu@arm.com>

meson will natively compile and generate the sanitycheck.exe file.  It will
be spawned and run at the host side.  Export the cross compiler is not
necessary as it is already done by the cross-file, and even worse it
generate the files in the wrong target format.

The fix to the following compiling error is select the native compiler for
the sanity test source file.

Traceback (most recent call last): File
"/usr/share/meson/mesonbuild/mesonmain.py", line 361, in run app.generate()
File "/usr/share/meson/mesonbuild/mesonmain.py", line 150, in generate
self._generate(env) File "/usr/share/meson/mesonbuild/mesonmain.py", line
189, in _generate intr = interpreter.Interpreter(b, g) File
"/usr/share/meson/mesonbuild/interpreter.py", line 1444, in __init__
self.parse_project() File "/usr/share/meson/mesonbuild/interpreterbase.py",
line 159, in parse_project self.evaluate_codeblock(self.ast, end=1) File
"/usr/share/meson/mesonbuild/interpreterbase.py", line 195, in
evaluate_codeblock raise e File
"/usr/share/meson/mesonbuild/interpreterbase.py", line 189, in
evaluate_codeblock self.evaluate_statement(cur) File
"/usr/share/meson/mesonbuild/interpreterbase.py", line 200, in
evaluate_statement return self.function_call(cur) File
"/usr/share/meson/mesonbuild/interpreterbase.py", line 456, in
function_call return self.funcs[func_name](node, self.flatten(posargs),
kwargs) File "/usr/share/meson/mesonbuild/interpreterbase.py", line 55, in
wrapped return f(self, node, args, kwargs) File
"/usr/share/meson/mesonbuild/interpreterbase.py", line 79, in wrapped
return f(s, node_or_state, args, kwargs) File
"/usr/share/meson/mesonbuild/interpreter.py", line 1947, in func_project
self.add_languages(proj_langs, True) File
"/usr/share/meson/mesonbuild/interpreter.py", line 2078, in add_languages
(comp, cross_comp) = self.detect_compilers(lang, need_cross_compiler) File
"/usr/share/meson/mesonbuild/interpreter.py", line 2047, in
detect_compilers comp.sanity_check(self.environment.get_scratch_dir(),
self.environment) File "/usr/share/meson/mesonbuild/compilers/c.py", line
254, in sanity_check return self.sanity_check_impl(work_dir, environment,
'sanitycheckc.c', code) File "/usr/share/meson/mesonbuild/compilers/c.py",
line 247, in sanity_check_impl pe = subprocess.Popen(cmdlist) File
"/usr/lib/python3.5/subprocess.py", line 676, in __init__ restore_signals,
start_new_session) File "/usr/lib/python3.5/subprocess.py", line 1282, in
_execute_child raise child_exception_type(errno_num, err_msg) OSError:
[Errno 8] Exec format error

Build started at 2018-06-01T12:48:46.852286 Main binary: /usr/bin/python3
Python system: Linux The Meson build system Version: 0.45.1 Build type:
cross build Project name: DPDK Sanity testing C compiler:
aarch64-linux-gnu-gcc Is cross compiler: False.  Sanity check compiler
command line: aarch64-linux-gnu-gcc
dpdk/build-arm64-armv8/meson-private/sanitycheckc.c -o
dpdk/build-arm64-armv8/meson-private/sanitycheckc.exe

Fixes: a55277a788 ("devtools: add test script for meson builds")
Cc: stable@dpdk.org

Signed-off-by: Gavin Hu <gavin.hu@arm.com>
Reviewed-by: Phil Yang <phil.yang@arm.com>
Reviewed-by: Song Zhu <song.zhu@arm.com>
---
 devtools/test-meson-builds.sh | 11 +++++++----
 1 file changed, 7 insertions(+), 4 deletions(-)

diff --git a/devtools/test-meson-builds.sh b/devtools/test-meson-builds.sh
index 9868c325b..6bce3df7f 100755
--- a/devtools/test-meson-builds.sh
+++ b/devtools/test-meson-builds.sh
@@ -1,6 +1,7 @@
 #! /bin/sh -e
 # SPDX-License-Identifier: BSD-3-Clause
 # Copyright(c) 2018 Intel Corporation
+# Copyright(c) 2018 ARM Corporation
 
 # Run meson to auto-configure the various builds.
 # * all builds get put in a directory whose name starts with "build-"
@@ -18,7 +19,6 @@ build () # <directory> <meson options>
 		options="--werror -Dexamples=all $*"
 		echo "$MESON $options $srcdir $builddir"
 		$MESON $options $srcdir $builddir
-		unset CC
 	fi
 	echo "ninja -C $builddir"
 	ninja -C $builddir
@@ -26,10 +26,11 @@ build () # <directory> <meson options>
 
 # shared and static linked builds with gcc and clang
 for c in gcc clang ; do
+	export CC="ccache $c"
 	for s in static shared ; do
-		export CC="ccache $c"
 		build build-$c-$s --default-library=$s
 	done
+	unset CC
 done
 
 # test compilation with minimal x86 instruction set
@@ -39,8 +40,10 @@ build build-x86-default -Dmachine=nehalem
 for f in config/arm/arm*gcc ; do
 	c=aarch64-linux-gnu-gcc
 	if ! command -v $c >/dev/null 2>&1 ; then
-		continue
+		echo "## ERROR: aarch64-linux-gnu-gcc is missing..."
+		exit 1
 	fi
-	export CC="ccache $c"
+	export CC="ccache gcc"
 	build build-$(basename $f | tr '_' '-' | cut -d'-' -f-2) --cross-file $f
+	unset CC
 done
-- 
2.11.0

  parent reply	other threads:[~2018-06-14  9:51 UTC|newest]

Thread overview: 59+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-05-24  3:38 [dpdk-dev] [PATCH 0/2] *** gcc cross compile dpdk *** Gavin Hu
2018-05-24  3:38 ` [dpdk-dev] [PATCH 1/2] mk: fix cross build errors Gavin Hu
2018-05-24 13:46   ` [dpdk-dev] [dpdk-stable] " Thomas Monjalon
2018-05-25  7:53     ` Gavin Hu
2018-05-24  3:38 ` [dpdk-dev] [PATCH 2/2] doc: add a guide doc for cross compiling from x86 Gavin Hu
2018-05-24 10:45   ` Kovacevic, Marko
2018-05-24 10:47     ` Kovacevic, Marko
2018-05-24 11:17   ` Jerin Jacob
2018-05-24 13:20     ` Bruce Richardson
2018-05-25  7:00       ` Gavin Hu
2018-05-24 13:54     ` Thomas Monjalon
2018-05-24 17:16       ` Jerin Jacob
2018-05-24 20:31         ` Thomas Monjalon
2018-05-28  6:53 ` [dpdk-dev] [PATCH v2 1/2] mk: fix cross build errors Gavin Hu
2018-05-28  6:53   ` [dpdk-dev] [PATCH v2 2/2] doc: add a guide doc for cross compiling from x86 Gavin Hu
2018-05-28 13:25     ` Bruce Richardson
2018-05-29  1:24       ` Gavin Hu
2018-05-28 16:01     ` Kovacevic, Marko
2018-05-28 13:24   ` [dpdk-dev] [PATCH v2 1/2] mk: fix cross build errors Bruce Richardson
2018-05-29  1:22     ` Gavin Hu
2018-05-29 14:45     ` [dpdk-dev] [dpdk-stable] " Thomas Monjalon
2018-05-29 15:00       ` Bruce Richardson
2018-05-29 16:20         ` Gavin Hu
2018-05-29 19:53           ` Thomas Monjalon
2018-05-29  6:51   ` [dpdk-dev] [PATCH v3 " Gavin Hu
2018-05-29  6:51     ` [dpdk-dev] [PATCH v3 2/2] doc: add a guide doc for cross compiling from x86 Gavin Hu
2018-05-29  7:21     ` [dpdk-dev] [PATCH v4 0/2] *** cross gcc fix and guide doc *** Gavin Hu
2018-05-29  7:21       ` [dpdk-dev] [PATCH v4 1/2] mk: fix cross build errors Gavin Hu
2018-05-29  7:21       ` [dpdk-dev] [PATCH v4 2/2] doc: add a guide doc for cross compiling from x86 Gavin Hu
2018-05-29  8:39         ` Kovacevic, Marko
2018-05-29 10:43       ` [dpdk-dev] [PATCH v5 0/2] *** cross gcc compile fix and add a guide doc *** Gavin Hu
2018-05-29 10:43         ` [dpdk-dev] [PATCH v5 1/2] mk: fix cross build errors Gavin Hu
2018-05-29 15:09           ` [dpdk-dev] [dpdk-stable] " Thomas Monjalon
2018-05-29 10:43         ` [dpdk-dev] [PATCH v5 2/2] doc: add a guide doc for cross compiling from x86 Gavin Hu
2018-05-29 13:33           ` Kovacevic, Marko
2018-05-30 19:16           ` Thomas Monjalon
2018-05-30 19:35           ` Jerin Jacob
2018-06-04  6:03             ` Gavin Hu
2018-06-04 12:50               ` Jerin Jacob
2018-06-12  1:27                 ` Gavin Hu
2018-06-12 12:06                   ` Gavin Hu
2018-06-12 12:11                     ` Thomas Monjalon
2018-06-14  9:51         ` [dpdk-dev] [PATCH v6 0/7] *** fix the cross compile errors *** Gavin Hu
2018-06-14  9:51           ` [dpdk-dev] [PATCH v6 1/7] mk: fix cross build errors Gavin Hu
2018-06-14  9:51           ` [dpdk-dev] [PATCH v6 2/7] doc: add a guide doc for cross compiling from x86 Gavin Hu
2018-06-14  9:51           ` Gavin Hu [this message]
2018-06-14 10:34             ` [dpdk-dev] [PATCH v6 3/7] devtools: fix the Exec format error Bruce Richardson
2018-06-15  8:07               ` Gavin Hu
2018-06-14  9:51           ` [dpdk-dev] [PATCH v6 4/7] build: fix the meson build warning Gavin Hu
2018-06-14 10:34             ` Bruce Richardson
2018-06-14  9:51           ` [dpdk-dev] [PATCH v6 5/7] devtools: fix the missing ninja command error on CentOS Gavin Hu
2018-06-14 10:40             ` Bruce Richardson
2018-06-15  8:08               ` Gavin Hu
2018-06-14  9:51           ` [dpdk-dev] [PATCH v6 6/7] build: fix the meson cross compile error Gavin Hu
2018-06-14 10:42             ` Bruce Richardson
2018-06-14  9:51           ` [dpdk-dev] [PATCH v6 7/7] devtools: expand meson cross compiling coverage Gavin Hu
2018-06-14 10:45             ` Bruce Richardson
2018-06-15  8:09               ` Gavin Hu
2018-06-15 10:23               ` Gavin Hu

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20180614095127.16245-4-gavin.hu@arm.com \
    --to=gavin.hu@arm.com \
    --cc=dev@dpdk.org \
    --cc=stable@dpdk.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).